



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#、Java和JS实现SHA256+BASE64加密总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#、Java和JS实现SHA256+BASE64加密总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 22:44:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>C#、Java和JS实现SHA256+BASE64加密总结</h1>
<p>--莫非(www.muphy.me)</p>
<h2>原理</h2>
<p>首先，通过编码格式（UTF-8、ASCII等，如果含有汉字等字符，编码格式不同加密结果也不同）获得加密字符串的字节数组，再计算字节数组的哈希值数组，再把hash数组转换为base64编码的字符串。</p>
<h2>C#实例</h2>
<div>
<pre class="prettyprint linenums">class  Program

   {//转换为base64编码为44位

       public  static  string NewSHA256(string  str)

       {

           //如果str有中文，不同Encoding的sha是不同的！！

          using  (SHA256Managed  sha256 = new SHA256Managed())

           {

              byte[] SHA256Data  =Encoding.UTF8.GetBytes(str);

//SHA256Data  "104,101,108,108,111,32,119,111,114,108,100"

              byte[] by  =sha256.ComputeHash(SHA256Data);

//44位 "uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek="

               return  Convert.ToBase64String(by);  

           }

       }

       //转换为十六进制编码为64位  去除了&lsquo;-&rsquo;

       public  static  string SHA256(string  str)

       { //如果str有中文，不同Encoding的sha是不同的！！

          using  (SHA256Managed  sha256 = new SHA256Managed())

           {

              byte[] SHA256Data  =Encoding.UTF8.GetBytes(str);

//SHA256Data "104,101,108,108,111,32,119,111,114,108,100"

              byte[] by  =sha256.ComputeHash(SHA256Data);

//64位 "b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9"

               return  BitConverter.ToString(by).Replace("-", "").ToLower();

           }

       }

       static  void Main(string[] args)

       {

          string  s  = "hello world";

//sha265：b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9

          string  sha  = SHA256(s);

          Console.WriteLine("{0}\n{1} \nLength: {2}", s, sha,sha.Length);

          //结果 &rdquo;uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=&rdquo;

       }

}</pre>
</div>
<h2>Java实例</h2>
<div>
<pre class="prettyprint linenums">/**

    *  利用java原生的摘要实现SHA256加密

    *@param  str  加密后的报文

    *@return

    */

   public  static  String getSHA256StrJava(String  str){

      MessageDigest  messageDigest;

       String  encodeStr = "";

       try  {

          messageDigest  =MessageDigest.getInstance("SHA-256");

          messageDigest.update(str.getBytes("UTF-8"));

           //转换的方式选择

           //encodeStr  = byte2Hex(messageDigest.digest());//转换成二进制

          encodeStr  =base64Entrypt(messageDigest.digest());//转换成Base64

       } catch  (NoSuchAlgorithmException  e) {

          e.printStackTrace();

       } catch  (UnsupportedEncodingException  e) {

          e.printStackTrace();

       }

       return  encodeStr;

   }

   /**

    *将byte转为16进制

    *@param  bytes

    *@return

    */

   private  static  String byte2Hex(byte[] bytes){

       StringBuffer  stringBuffer = new StringBuffer();

       String  temp  =null;

       for  (int i=;i&lt;bytes.length;i++){

          temp  =Integer.toHexString(bytes[i] &amp; 0xFF);

           if  (temp.length()==){

               //1得到一位的进行补0操作

               stringBuffer.append("");

           }

          stringBuffer.append(temp);

       }

       return  stringBuffer.toString();

}

/**

    *转换为BASE64编码

    *@param  bytes

    *@return

    */

   private  static  String base64Entrypt(byte[] bytes){

   //import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

   return  Base64.encode(bytes);

   }

   private  static  String newBase64Entrypt(byte[] bytes){

        //import sun.misc.BASE64Encoder;

        return  new  BASE64Encoder().encode(bytes);

   }

   /**

    *测试

    *@param  Args

    */

   public  static  void main(String[] Args){

   String str  = "hello  world";

   String sha  = getSHA256StrJava(str);

   System.out.println(str  + ":" + sha);

   //结果：hello world:uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=

}</pre>
</div>
<h2>JS实例</h2>
<div>
<pre class="prettyprint linenums">/**

*SHA256加密

*/

function  SHA256(s) {

 var  chrsz = 8;

 var  hexcase = 0;

 function  safe_add(x, y) {

     var  lsw  =(x  &amp; 0xFFFF) + (y  &amp; 0xFFFF);

     var  msw  =(x  &gt;&gt; 16) + (y  &gt;&gt; 16) + (lsw  &gt;&gt; 16);

     return  (msw &lt;&lt; 16) | (lsw  &amp;0xFFFF);

 }

 function  S(X, n) {

     return  (X &gt;&gt;&gt; n) | (X  &lt;&lt;(32  - n));

 }

 function  R(X, n) {

     return  (X &gt;&gt;&gt; n);

 }

 function  Ch(x, y, z) {

     return  ((x &amp; y) ^ ((~x) &amp; z));

 }

 function  Maj(x, y, z) {

     return  ((x &amp; y) ^ (x  &amp; z) ^ (y  &amp; z));

 }

 function  Sigma0256(x) {

     return  (S(x, 2) ^ S(x, 13) ^ S(x, 22));

 }

 function  Sigma1256(x) {

     return  (S(x, 6) ^ S(x, 11) ^ S(x, 25));

 }

 function  Gamma0256(x) {

     return  (S(x, 7) ^ S(x, 18) ^ R(x, 3));

 }

 function  Gamma1256(x) {

     return  (S(x, 17) ^ S(x, 19) ^ R(x, 10));

 }

 function  core_sha256(m, l) {

     var  K  = new  Array(0x428A2F98, 0x71374491, 0xB5C0FBCF,0xE9B5DBA5,

             0x3956C25B, 0x59F111F1, 0x923F82A4,0xAB1C5ED5, 0xD807AA98,

             0x12835B01, 0x243185BE,0x550C7DC3, 0x72BE5D74, 0x80DEB1FE,

             0x9BDC06A7, 0xC19BF174,0xE49B69C1, 0xEFBE4786, 0xFC19DC6,

             0x240CA1CC, 0x2DE92C6F,0x4A7484AA, 0x5CB0A9DC, 0x76F988DA,

             0x983E5152, 0xA831C66D, 0xB00327C8,0xBF597FC7, 0xC6E00BF3,

             0xD5A79147, 0x6CA6351, 0x14292967,0x27B70A85, 0x2E1B2138,

             0x4D2C6DFC, 0x53380D13,0x650A7354, 0x766A0ABB, 0x81C2C92E,

             0x92722C85, 0xA2BFE8A1,0xA81A664B, 0xC24B8B70, 0xC76C51A3,

             0xD192E819, 0xD6990624, 0xF40E3585,0x106AA070, 0x19A4C116,

             0x1E376C08, 0x2748774C,0x34B0BCB5, 0x391C0CB3, 0x4ED8AA4A,

             0x5B9CCA4F, 0x682E6FF3,0x748F82EE, 0x78A5636F, 0x84C87814,

             0x8CC70208, 0x90BEFFFA,0xA4506CEB, 0xBEF9A3F7, 0xC67178F2);

     var  HASH  =new  Array(0x6A09E667,0xBB67AE85, 0x3C6EF372, 0xA54FF53A,

             0x510E527F, 0x9B05688C,0x1F83D9AB, 0x5BE0CD19);

     var  W  = new  Array(64);

     var  a, b, c, d, e, f, g, h, i, j;

     var  T1, T2;

     m[l &gt;&gt; 5] |= 0x80  &lt;&lt;(24  - l % 32);

     m[((l + 64  &gt;&gt; 9) &lt;&lt; 4) +15] = l;

     for  (var  i  = 0;i  &lt; m.length; i  += 16) {

         a = HASH[0];

         b = HASH[1];

         c = HASH[2];

         d = HASH[3];

         e = HASH[4];

         f = HASH[5];

         g = HASH[6];

         h = HASH[7];

         for  (var  j  = 0;j  &lt; 64; j++) {

             if  (j &lt; 16)

                 W[j] = m[j  + i];

             else

                 W[j] =safe_add(safe_add(safe_add(Gamma1256(W[j - 2]),

                         W[j  - 7]), Gamma0256(W[j  - 15])), W[j - 16]);

             T1 = safe_add(safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(

                     e, f, g)), K[j]), W[j]);

             T2 = safe_add(Sigma0256(a), Maj(a, b, c));

             h = g;

             g = f;

             f = e;

             e = safe_add(d, T1);

             d = c;

             c = b;

             b = a;

             a = safe_add(T1, T2);

         }

         HASH[0] = safe_add(a, HASH[0]);

         HASH[1] = safe_add(b, HASH[1]);

         HASH[2] = safe_add(c, HASH[2]);

         HASH[3] = safe_add(d, HASH[3]);

         HASH[4] = safe_add(e, HASH[4]);

         HASH[5] = safe_add(f, HASH[5]);

         HASH[6] = safe_add(g, HASH[6]);

         HASH[7] = safe_add(h, HASH[7]);

     }

     return  HASH;

 }

 function  str2binb(str) {

     var  bin  =Array();

     var  mask  =(1  &lt;&lt; chrsz) - 1;

     for  (var  i  = 0;i  &lt; str.length  * chrsz; i += chrsz) {

         bin[i &gt;&gt; 5] |= (str.charCodeAt(i / chrsz) &amp; mask) &lt;&lt; (24 - i  % 32);

     }

     return  bin;

 }

 function  Utf8Encode(string) {

     string = string.replace(/\r\n/g, "\n");

     var  utftext = "";

     for  (var  n  = 0;n  &lt; string.length; n++) {

         var  c  =string.charCodeAt(n);

         if  (c &lt; 128) {

             utftext  += String.fromCharCode(c);

         } else  if  ((c &gt; 127) &amp;&amp; (c  &lt;2048)) {

             utftext  += String.fromCharCode((c  &gt;&gt; 6) | 192);

             utftext  += String.fromCharCode((c  &amp; 63) | 128);

         } else  {

             utftext  += String.fromCharCode((c  &gt;&gt; 12) | 224);

             utftext  += String.fromCharCode(((c  &gt;&gt; 6) &amp; 63) | 128);

             utftext  += String.fromCharCode((c  &amp; 63) | 128);

         }

     }

     return  utftext;

 }

 function  binb2hex(binarray) {

     var  hex_tab = hexcase  ? "0123456789ABCDEF" : "0123456789abcdef";

     var  str  = "";

     for  (var  i  = 0;i  &lt; binarray.length  * 4; i++) {

         str += hex_tab

                 .charAt((binarray[i  &gt;&gt; 2] &gt;&gt; ((3  - i  %4) * 8  + 4)) &amp; 0xF)

                 + hex_tab.charAt((binarray[i&gt;&gt; 2] &gt;&gt; ((3 - i % 4) * 8)) &amp; 0xF);

     }

     return  str;

 }

 s  =Utf8Encode(s);

 return  binb2hex(core_sha256(str2binb(s), s.length *chrsz));

}</pre>
</div>
<h1>C#、Java和JS实现SHA256+BASE64加密总结</h1>
<p>--莫非(www.muphy.me)</p>
<h2>原理</h2>
<p>首先，通过编码格式（UTF-8、ASCII等，如果含有汉字等字符，编码格式不同加密结果也不同）获得加密字符串的字节数组，再计算字节数组的哈希值数组，再把hash数组转换为base64编码的字符串。</p>
<h2>C#实例</h2>
<p><strong>class</strong>&nbsp;&nbsp;Program</p>
<p>{//转换为base64编码为44位</p>
<p><strong>public</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;string NewSHA256(string &nbsp;str)</p>
<p>{</p>
<p>//如果str有中文，不同Encoding的sha是不同的！！</p>
<p>using &nbsp;(SHA256Managed &nbsp;sha256 =&nbsp;<strong>new</strong>&nbsp;SHA256Managed())</p>
<p>{</p>
<p>byte[] SHA256Data &nbsp;=Encoding.UTF8.GetBytes(str);</p>
<p>//SHA256Data &nbsp;"104,101,108,108,111,32,119,111,114,108,100"</p>
<p>byte[] by &nbsp;=sha256.ComputeHash(SHA256Data);</p>
<p>//44位&nbsp;"uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek="</p>
<p><strong>return</strong>&nbsp;&nbsp;Convert.ToBase64String(by);</p>
<p>}</p>
<p>}</p>
<p>//转换为十六进制编码为64位&nbsp;&nbsp;去除了&lsquo;-&rsquo;</p>
<p><strong>public</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;string SHA256(string &nbsp;str)</p>
<p>{&nbsp;//如果str有中文，不同Encoding的sha是不同的！！</p>
<p>using &nbsp;(SHA256Managed &nbsp;sha256 =&nbsp;<strong>new</strong>&nbsp;SHA256Managed())</p>
<p>{</p>
<p>byte[] SHA256Data &nbsp;=Encoding.UTF8.GetBytes(str);</p>
<p>//SHA256Data "104,101,108,108,111,32,119,111,114,108,100"</p>
<p>byte[] by &nbsp;=sha256.ComputeHash(SHA256Data);</p>
<p>//64位&nbsp;"b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9"</p>
<p><strong>return</strong>&nbsp;&nbsp;BitConverter.ToString(by).Replace("-",&nbsp;"").ToLower();</p>
<p>}</p>
<p>}</p>
<p><strong>static</strong>&nbsp;&nbsp;void Main(string[] args)</p>
<p>{</p>
<p>string &nbsp;s &nbsp;=&nbsp;"hello world";</p>
<p>//sha265：b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9</p>
<p>string &nbsp;sha &nbsp;= SHA256(s);</p>
<p>Console.WriteLine("{0}\n{1} \nLength: {2}", s, sha,sha.Length);</p>
<p>//结果&nbsp;&rdquo;uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=&rdquo;</p>
<p>}</p>
<p>}</p>
<h2>Java实例</h2>
<p>/**</p>
<p>*&nbsp;&nbsp;利用java原生的摘要实现SHA256加密</p>
<p>*<strong>@param</strong>&nbsp;&nbsp;str&nbsp;&nbsp;加密后的报文</p>
<p>*<strong>@return</strong></p>
<p>*/</p>
<p><strong>public</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;String getSHA256StrJava(String &nbsp;str){</p>
<p>MessageDigest &nbsp;messageDigest;</p>
<p>String &nbsp;encodeStr =&nbsp;"";</p>
<p><strong>try</strong>&nbsp;&nbsp;{</p>
<p>messageDigest &nbsp;=MessageDigest.getInstance("SHA-256");</p>
<p>messageDigest.update(str.getBytes("UTF-8"));</p>
<p>//转换的方式选择</p>
<p>//encodeStr &nbsp;= byte2Hex(messageDigest.digest());//转换成二进制</p>
<p>encodeStr &nbsp;=base64Entrypt(messageDigest.digest());//转换成Base64</p>
<p>}&nbsp;<strong>catch</strong>&nbsp;&nbsp;(NoSuchAlgorithmException &nbsp;e) {</p>
<p>e.printStackTrace();</p>
<p>}&nbsp;<strong>catch</strong>&nbsp;&nbsp;(UnsupportedEncodingException &nbsp;e) {</p>
<p>e.printStackTrace();</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;encodeStr;</p>
<p>}</p>
<p>/**</p>
<p>*将byte转为16进制</p>
<p>*<strong>@param</strong>&nbsp;&nbsp;bytes</p>
<p>*<strong>@return</strong></p>
<p>*/</p>
<p><strong>private</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;String byte2Hex(byte[] bytes){</p>
<p>StringBuffer &nbsp;stringBuffer =&nbsp;<strong>new</strong>&nbsp;StringBuffer();</p>
<p>String &nbsp;temp &nbsp;=<strong>null</strong>;</p>
<p><strong>for</strong>&nbsp;&nbsp;(int i=0;i&lt;bytes.length;i++){</p>
<p>temp &nbsp;=Integer.toHexString(bytes[i] &amp; 0xFF);</p>
<p><strong>if</strong>&nbsp;&nbsp;(temp.length()==1){</p>
<p>//1得到一位的进行补0操作</p>
<p>stringBuffer.append("0");</p>
<p>}</p>
<p>stringBuffer.append(temp);</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;stringBuffer.toString();</p>
<p>}</p>
<p>/**</p>
<p>*转换为BASE64编码</p>
<p>*<strong>@param</strong>&nbsp;&nbsp;bytes</p>
<p>*<strong>@return</strong></p>
<p>*/</p>
<p><strong>private</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;String base64Entrypt(byte[] bytes){</p>
<p>//import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;</p>
<p><strong>return</strong>&nbsp;&nbsp;Base64.encode(bytes);</p>
<p>}</p>
<p><strong>private</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;String newBase64Entrypt(byte[] bytes){</p>
<p>//import sun.misc.BASE64Encoder;</p>
<p><strong>return</strong>&nbsp;&nbsp;<strong>new</strong>&nbsp;&nbsp;BASE64Encoder().encode(bytes);</p>
<p>}</p>
<p>/**</p>
<p>*测试</p>
<p>*<strong>@param</strong>&nbsp;&nbsp;Args</p>
<p>*/</p>
<p><strong>public</strong>&nbsp;&nbsp;<strong>static</strong>&nbsp;&nbsp;void main(String[] Args){</p>
<p>String str &nbsp;=&nbsp;"hello &nbsp;world";</p>
<p>String sha &nbsp;= getSHA256StrJava(str);</p>
<p>System.out.println(str &nbsp;+&nbsp;":"&nbsp;+ sha);</p>
<p>//结果：hello world:uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=</p>
<p>}</p>
<h2>JS实例</h2>
<p>/**</p>
<p>*SHA256加密</p>
<p>*/</p>
<p><strong>function</strong>&nbsp;&nbsp;SHA256(s) {</p>
<p><strong>var</strong>&nbsp;&nbsp;chrsz = 8;</p>
<p><strong>var</strong>&nbsp;&nbsp;hexcase = 0;</p>
<p><strong>function</strong>&nbsp;&nbsp;safe_add(x, y) {</p>
<p><strong>var</strong>&nbsp;&nbsp;lsw &nbsp;=(x &nbsp;&amp; 0xFFFF) + (y &nbsp;&amp; 0xFFFF);</p>
<p><strong>var</strong>&nbsp;&nbsp;msw &nbsp;=(x &nbsp;&gt;&gt; 16) + (y &nbsp;&gt;&gt; 16) + (lsw &nbsp;&gt;&gt; 16);</p>
<p><strong>return</strong>&nbsp;&nbsp;(msw &lt;&lt; 16) | (lsw &nbsp;&amp;0xFFFF);</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;S(X, n) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(X &gt;&gt;&gt; n) | (X &nbsp;&lt;&lt;(32 &nbsp;- n));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;R(X, n) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(X &gt;&gt;&gt; n);</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Ch(x, y, z) {</p>
<p><strong>return</strong>&nbsp;&nbsp;((x &amp; y) ^ ((~x) &amp; z));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Maj(x, y, z) {</p>
<p><strong>return</strong>&nbsp;&nbsp;((x &amp; y) ^ (x &nbsp;&amp; z) ^ (y &nbsp;&amp; z));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Sigma0256(x) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(S(x, 2) ^ S(x, 13) ^ S(x, 22));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Sigma1256(x) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(S(x, 6) ^ S(x, 11) ^ S(x, 25));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Gamma0256(x) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(S(x, 7) ^ S(x, 18) ^ R(x, 3));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Gamma1256(x) {</p>
<p><strong>return</strong>&nbsp;&nbsp;(S(x, 17) ^ S(x, 19) ^ R(x, 10));</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;core_sha256(m, l) {</p>
<p><strong>var</strong>&nbsp;&nbsp;K &nbsp;=&nbsp;<strong>new</strong>&nbsp;&nbsp;Array(0x428A2F98, 0x71374491, 0xB5C0FBCF,0xE9B5DBA5,</p>
<p>0x3956C25B, 0x59F111F1, 0x923F82A4,0xAB1C5ED5, 0xD807AA98,</p>
<p>0x12835B01, 0x243185BE,0x550C7DC3, 0x72BE5D74, 0x80DEB1FE,</p>
<p>0x9BDC06A7, 0xC19BF174,0xE49B69C1, 0xEFBE4786, 0xFC19DC6,</p>
<p>0x240CA1CC, 0x2DE92C6F,0x4A7484AA, 0x5CB0A9DC, 0x76F988DA,</p>
<p>0x983E5152, 0xA831C66D, 0xB00327C8,0xBF597FC7, 0xC6E00BF3,</p>
<p>0xD5A79147, 0x6CA6351, 0x14292967,0x27B70A85, 0x2E1B2138,</p>
<p>0x4D2C6DFC, 0x53380D13,0x650A7354, 0x766A0ABB, 0x81C2C92E,</p>
<p>0x92722C85, 0xA2BFE8A1,0xA81A664B, 0xC24B8B70, 0xC76C51A3,</p>
<p>0xD192E819, 0xD6990624, 0xF40E3585,0x106AA070, 0x19A4C116,</p>
<p>0x1E376C08, 0x2748774C,0x34B0BCB5, 0x391C0CB3, 0x4ED8AA4A,</p>
<p>0x5B9CCA4F, 0x682E6FF3,0x748F82EE, 0x78A5636F, 0x84C87814,</p>
<p>0x8CC70208, 0x90BEFFFA,0xA4506CEB, 0xBEF9A3F7, 0xC67178F2);</p>
<p><strong>var</strong>&nbsp;&nbsp;HASH &nbsp;=<strong>new</strong>&nbsp;&nbsp;Array(0x6A09E667,0xBB67AE85, 0x3C6EF372, 0xA54FF53A,</p>
<p>0x510E527F, 0x9B05688C,0x1F83D9AB, 0x5BE0CD19);</p>
<p><strong>var</strong>&nbsp;&nbsp;W &nbsp;=&nbsp;<strong>new</strong>&nbsp;&nbsp;Array(64);</p>
<p><strong>var</strong>&nbsp;&nbsp;a, b, c, d, e, f, g, h, i, j;</p>
<p><strong>var</strong>&nbsp;&nbsp;T1, T2;</p>
<p>m[l &gt;&gt; 5] |= 0x80 &nbsp;&lt;&lt;(24 &nbsp;- l % 32);</p>
<p>m[((l + 64 &nbsp;&gt;&gt; 9) &lt;&lt; 4) +15] = l;</p>
<p><strong>for</strong>&nbsp;&nbsp;(<strong>var</strong>&nbsp;&nbsp;i &nbsp;= 0;i &nbsp;&lt; m.length; i &nbsp;+= 16) {</p>
<p>a = HASH[0];</p>
<p>b = HASH[1];</p>
<p>c = HASH[2];</p>
<p>d = HASH[3];</p>
<p>e = HASH[4];</p>
<p>f = HASH[5];</p>
<p>g = HASH[6];</p>
<p>h = HASH[7];</p>
<p><strong>for</strong>&nbsp;&nbsp;(<strong>var</strong>&nbsp;&nbsp;j &nbsp;= 0;j &nbsp;&lt; 64; j++) {</p>
<p><strong>if</strong>&nbsp;&nbsp;(j &lt; 16)</p>
<p>W[j] = m[j &nbsp;+ i];</p>
<p><strong>else</strong></p>
<p>W[j] =safe_add(safe_add(safe_add(Gamma1256(W[j - 2]),</p>
<p>W[j &nbsp;- 7]), Gamma0256(W[j &nbsp;- 15])), W[j - 16]);</p>
<p>T1 = safe_add(safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(</p>
<p>e, f, g)), K[j]), W[j]);</p>
<p>T2 = safe_add(Sigma0256(a), Maj(a, b, c));</p>
<p>h = g;</p>
<p>g = f;</p>
<p>f = e;</p>
<p>e = safe_add(d, T1);</p>
<p>d = c;</p>
<p>c = b;</p>
<p>b = a;</p>
<p>a = safe_add(T1, T2);</p>
<p>}</p>
<p>HASH[0] = safe_add(a, HASH[0]);</p>
<p>HASH[1] = safe_add(b, HASH[1]);</p>
<p>HASH[2] = safe_add(c, HASH[2]);</p>
<p>HASH[3] = safe_add(d, HASH[3]);</p>
<p>HASH[4] = safe_add(e, HASH[4]);</p>
<p>HASH[5] = safe_add(f, HASH[5]);</p>
<p>HASH[6] = safe_add(g, HASH[6]);</p>
<p>HASH[7] = safe_add(h, HASH[7]);</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;HASH;</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;str2binb(str) {</p>
<p><strong>var</strong>&nbsp;&nbsp;bin &nbsp;=Array();</p>
<p><strong>var</strong>&nbsp;&nbsp;mask &nbsp;=(1 &nbsp;&lt;&lt; chrsz) - 1;</p>
<p><strong>for</strong>&nbsp;&nbsp;(<strong>var</strong>&nbsp;&nbsp;i &nbsp;= 0;i &nbsp;&lt; str.length &nbsp;* chrsz; i += chrsz) {</p>
<p>bin[i &gt;&gt; 5] |= (str.charCodeAt(i / chrsz) &amp; mask) &lt;&lt; (24 - i &nbsp;% 32);</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;bin;</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;Utf8Encode(string) {</p>
<p>string = string.replace(/\r\n/g,&nbsp;"\n");</p>
<p><strong>var</strong>&nbsp;&nbsp;utftext =&nbsp;"";</p>
<p><strong>for</strong>&nbsp;&nbsp;(<strong>var</strong>&nbsp;&nbsp;n &nbsp;= 0;n &nbsp;&lt; string.length; n++) {</p>
<p><strong>var</strong>&nbsp;&nbsp;c &nbsp;=string.charCodeAt(n);</p>
<p><strong>if</strong>&nbsp;&nbsp;(c &lt; 128) {</p>
<p>utftext &nbsp;+= String.fromCharCode(c);</p>
<p>}&nbsp;<strong>else</strong>&nbsp;&nbsp;<strong>if</strong>&nbsp;&nbsp;((c &gt; 127) &amp;&amp; (c &nbsp;&lt;2048)) {</p>
<p>utftext &nbsp;+= String.fromCharCode((c &nbsp;&gt;&gt; 6) | 192);</p>
<p>utftext &nbsp;+= String.fromCharCode((c &nbsp;&amp; 63) | 128);</p>
<p>}&nbsp;<strong>else</strong>&nbsp;&nbsp;{</p>
<p>utftext &nbsp;+= String.fromCharCode((c &nbsp;&gt;&gt; 12) | 224);</p>
<p>utftext &nbsp;+= String.fromCharCode(((c &nbsp;&gt;&gt; 6) &amp; 63) | 128);</p>
<p>utftext &nbsp;+= String.fromCharCode((c &nbsp;&amp; 63) | 128);</p>
<p>}</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;utftext;</p>
<p>}</p>
<p><strong>function</strong>&nbsp;&nbsp;binb2hex(binarray) {</p>
<p><strong>var</strong>&nbsp;&nbsp;hex_tab = hexcase &nbsp;?&nbsp;"0123456789ABCDEF"&nbsp;:&nbsp;"0123456789abcdef";</p>
<p><strong>var</strong>&nbsp;&nbsp;str &nbsp;=&nbsp;"";</p>
<p><strong>for</strong>&nbsp;&nbsp;(<strong>var</strong>&nbsp;&nbsp;i &nbsp;= 0;i &nbsp;&lt; binarray.length &nbsp;* 4; i++) {</p>
<p>str += hex_tab</p>
<p>.charAt((binarray[i &nbsp;&gt;&gt; 2] &gt;&gt; ((3 &nbsp;- i &nbsp;%4) * 8 &nbsp;+ 4)) &amp; 0xF)</p>
<p>+ hex_tab.charAt((binarray[i&gt;&gt; 2] &gt;&gt; ((3 - i % 4) * 8)) &amp; 0xF);</p>
<p>}</p>
<p><strong>return</strong>&nbsp;&nbsp;str;</p>
<p>}</p>
<p>s &nbsp;=Utf8Encode(s);</p>
<p><strong>return</strong>&nbsp;&nbsp;binb2hex(core_sha256(str2binb(s), s.length *chrsz));</p>
<p>}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnl1g9r.html">TODO：Go语言goroutine和channel使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gjer79.html">同一个页面多个page之间的切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv56ezq.html">改变HTML</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwe3mq.html">关于group by 两个或以上条件的分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v2okm8.html">UITableView基本使用和cell的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o52y49.html">集合类学习之HashMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zw2j09.html">JMX-JAVA进程监控利器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o1olv9.html">xmpp总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vjlzq.html">用Swift开发二维码扫描器教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1gwe8.html">Jenkins中关于一些插件的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2m0x9.html">Java中的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rv47o9.html">Django 数据迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlrdd9.html">mysql-语法大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1yggpq.html">JS常见的字符串操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj43m79.html">python多线程用法及与单线程耗时比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rgwe08.html">ABP的依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlrk6q.html">Fork&sol;Join编程模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2vnw9.html">vue 引入bootstarp --webpack</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p6p73q.html">metasploit出错信息：can&amp;&num;39&semi;t allocate memory</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp5gek9.html">系统管理命令之who</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zod2wvq.html">欧洲AI规范先行，值得肯定与借鉴 --- 我看欧盟发布AI道德规范</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zodprnq.html">ArcGIS Server较早版本切片迁移注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj1p4y8.html">Linux系统性能分析工具 sar--系统活动情况报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1m74gq.html">CGI 、FastCGI、PHP-CGI、PHP-FPM 定义以及与nginx的应用关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me35vpq.html">AngularJS学习之旅&mdash;AngularJS 控制器&lpar;六&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mz35m8.html">SQL语句中不同的连接JOIN</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zr0539.html">Win10解除网速限制让网速飞起来</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgeeme8.html">Django 简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z66pe9.html">applicationSettings设置和appsttings</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zrxl59.html">Docker（2）：使用Dockerfile创建支持SSH服务的镜像</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
